package dev.inmo.postssystem.features.common.common.ui

import dev.inmo.micro_utils.fsm.common.StatesMachine
import dev.inmo.postssystem.features.common.common.ui.fsm.*
import kotlinx.browser.document
import org.w3c.dom.HTMLElement

abstract class JSView<T : UIFSMState>(
    override val defaultExceptionsHandlers: Iterable<UIFSMExceptionHandler>
) : UIFSMHandler<T> {
    open suspend fun StatesMachine<in UIFSMState>.safeHandleState(
        htmlElement: HTMLElement,
        state: T
    ): UIFSMState? = null

    override suspend fun StatesMachine<in UIFSMState>.safeHandleState(state: T): UIFSMState? {
        return safeHandleState(document.getElementById(state.context) as? HTMLElement ?: return null, state)
    }
}
