package dev.inmo.postssystem.features.roles.client

import dev.inmo.micro_utils.coroutines.plus
import dev.inmo.micro_utils.coroutines.subscribeSafelyWithoutExceptions
import dev.inmo.postssystem.features.auth.client.settings.AuthSettings
import dev.inmo.postssystem.features.roles.common.Role
import dev.inmo.postssystem.features.roles.common.RolesStorage
import kotlinx.coroutines.CoroutineScope
import kotlinx.coroutines.flow.*
import org.koin.core.Koin

class DefaultRolesSettings(
    private val koin: Koin,
    private val authSettings: AuthSettings,
    private val scope: CoroutineScope
) : RolesSettings {
    private val _userRoles = MutableStateFlow<List<Role>>(emptyList())
    override val userRoles: StateFlow<List<Role>> = _userRoles.asStateFlow()

    val rolesUpdatingJob = (authSettings.user + authSettings.authorizedDIModule).subscribeSafelyWithoutExceptions(scope) {
        val user = authSettings.user.value

        if (user == null || authSettings.authorizedDIModule.value == null) {
            _userRoles.value = emptyList()
        } else {
            _userRoles.value = koin.get<RolesStorage<Role>>().getRoles(user.id)
        }
        println(user)
        println(userRoles.value)
    }
}
